
disteucl <- function(crds) {
# f
  if(is.vector(crds)) crds <- as.matrix(crds)
  dist <- matrix(0, nrow(crds), nrow(crds))
  for(i in 1:ncol(crds)) {
    dist <- dist + outer(crds[, i], crds[, i], "-")^2
  }
  dist <- sqrt(dist)
  return(dist)}

distp <- function(crdsp, crds) {
  if(is.vector(crds)) crds <- as.matrix(crds)
  dist <- rep(0, nrow(crds))
  for(i in 1:ncol(crds)) {
    dist <- dist + (rep(crdsp[i],nrow(crds)) - crds[,i])^2
  }
  dist <- sqrt(dist)
  return(dist)}


# definition des fonctions modeles de covariance et de variogramme
varexp <- function(h,c0,c1,scal){
  f = c0 + c1 * (1-exp(-h/scal))
  f[h==0] = 0
  return(f)
}

covexp <- function(h,c0,c1,scal)
{f = c1 * (exp(-h/scal))
 f[h==0] = c0 + c1
 return(f)
}

vargauss <- function(h,c0,c1,scal){
  f = c0 + c1 * (1-exp(-h^2/scal^2))
  f[h==0] = 0
  return(f)
}

covgauss <- function(h,c0,c1,scal)
{f = c1 * (exp(-h^2/scal^2))
 f[h==0] = c0 + c1
 return(f)
}


varsph <- function(h,c0,c1,scal){
    f = h
    f[h < scal] = c0 + 0.5*c1*( 3 * (h[h <scal]/scal) -(h[h <scal]/scal)^3)
    f[h == 0] = 0
    f[h > scal] = c0 + c1
return(f)
}


covsph <- function(h,c0,c1,scal){
  f = h
  f[h < scal] = c1 * (1 - 1.5 * (h[h <scal]/scal) + 0.5 * (h[h <scal]/scal)^3)
  f[h == 0] = c0 + c1
  f[h > scal] = 0
 return(f)
}



